import java.io.*;
import java.sql.*;
import java.text.*;

public class ejemplo
{
	Connection db;	// The connection to the database
	Statement st;	// Our statement to run queries with

	public ejemplo() throws ClassNotFoundException, FileNotFoundException, IOException, SQLException
	{
		
		// Load the driver
		Class.forName("org.postgresql.Driver");

		// Connect to database
		System.out.println("Connecting to Database URL ");
		db = DriverManager.getConnection("jdbc:postgresql://localhost/cc52k", "egodoy", "");

		System.out.println("Connected...Now creating a statement");
		st = db.createStatement();

		// Now run tests using JDBC methods
		doexample();

		// Finally close the database
		System.out.println("Now closing the connection");
		st.close();
		db.close();

		//throw postgresql.Driver.notImplemented();
	}

	/*
	 * This performs the example
	 */
	public void doexample() throws SQLException
	{
		System.out.println("\nRunning tests:");

		// Now insert some data, using the Statement
		st.executeUpdate("insert into empleados values (100,'K','TESTJDBC','JDBCAPELLIDO',now())");
		
		long insertedOID = ((org.postgresql.Statement)st).getLastOID();
		System.out.println("Inserted row with oid " + insertedOID);

		// Now change the value of b from 1 to 8
		st.executeUpdate("update empleados set dv='1' where rut=100");
		System.out.println("Updated " + st.getUpdateCount() + " rows");

		// Now delete  rows
		st.executeUpdate("delete from empleado_proyecto where id<5");
		System.out.println("deleted " + st.getUpdateCount() + " rows");

		PreparedStatement ps = db.prepareStatement("insert into proyectos values (?,?,?)");
		for (int i = 2;i < 5;i++)
		{
			ps.setInt(1, 40*i);		// "column a" = 5
			ps.setString(2, "Nombre"+i);		// "column b" = i
                        ps.setString(3,"Descripcion"+i);
			ps.executeUpdate(); // executeUpdate because insert returns no data
		}
		ps.close();			// Always close when we are done with it

		// Finally perform a query on the table
		System.out.println("performing a query");
		ResultSet rs = st.executeQuery("select * from proyectos");
		if (rs != null)
		{
			// Now we run through the result set, printing out the result.
			// Note, we must call .next() before attempting to read any results
			while (rs.next())
			{
				int id = rs.getInt("id"); // This shows how to get the value by name
				String b = rs.getString(2);	// This shows how to get the value by column
				System.out.println("  id=" + id + " nombre=" + b);
			}
			rs.close(); // again, you must close the result when done
		}

		// Now run the query again, showing a more efficient way of getting the
		// result if you don't know what column number a value is in


	}

	/*
	 * This little lot starts the test
	 */
	public static void main(String args[])
	{
		System.out.println("PostgreSQL Test\n");
		DriverManager.setLogStream(System.err);
		// Now run the tests
		try
		{
			ejemplo test = new ejemplo();
		}
		catch (Exception ex)
		{
			System.err.println("Exception caught.\n" + ex);
			ex.printStackTrace();
		}
	}
}
